----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:55:15 07/09/2010 
-- Design Name: 
-- Module Name:    AMC_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity AMC_if is
		Generic (useTCPIP : boolean := true; AMC_useTRIG : boolean := false; simulation : boolean := false);
    Port ( sysclk : in  STD_LOGIC;
					 ipb_clk : in std_logic;
					 clk125 : in std_logic;
					 DRPclk : in std_logic;
					 GTXreset : in  STD_LOGIC;
					 reset : in  STD_LOGIC;
					 resetCntr : in  STD_LOGIC;
					 ReSync : in  STD_LOGIC;
					 run : in  STD_LOGIC;
           Dis_pd : in  STD_LOGIC;
					 enSFP : IN std_logic_vector(3 downto 0);
					 en_localL1A : IN std_logic;
					 test : in  STD_LOGIC;
					 WaitMonBuf : in  STD_LOGIC;
					 fake_length	: in   std_logic_vector(17 downto 0);
           T1_version : in  STD_LOGIC_VECTOR(7 downto 0);
           Source_ID : in  STD_LOGIC_VECTOR(19 downto 0);
           AMC_en : in  STD_LOGIC_VECTOR(11 downto 0);
           AMC_Ready : out  STD_LOGIC_VECTOR(11 downto 0);
           BC0_lock : out  STD_LOGIC_VECTOR(11 downto 0);
					 AMC_REFCLK_P : in  STD_LOGIC;
					 AMC_REFCLK_N : in  STD_LOGIC;
           AMC_RXN : in  STD_LOGIC_VECTOR(12 downto 1);
           AMC_RXP : in  STD_LOGIC_VECTOR(12 downto 1);
           AMC_TXN : out  STD_LOGIC_VECTOR(12 downto 1);
           AMC_TXP : out  STD_LOGIC_VECTOR(12 downto 1);
           AMC_status : out  STD_LOGIC_VECTOR(31 downto 0);
					 evt_data : out array3X67;-- bit 66 is TCP/mon space, bit 65 is end_of_event and bit 64 is end_of_block
					 evt_data_re : in std_logic_vector(2 downto 0);
					 evt_buf_full : in std_logic_vector(2 downto 0);
					 evt_data_we : out std_logic_vector(2 downto 0);
					 evt_data_rdy : out std_logic_vector(2 downto 0);
					 ddr_pa	: in  STD_LOGIC_VECTOR(9 downto 0);
					 MonBuf_empty : in STD_LOGIC;
					 mon_evt_wc	: out STD_LOGIC_VECTOR (47 downto 0);
					 mon_ctrl	: out STD_LOGIC_VECTOR (31 downto 0);
-- buffer control
					 mon_buf_avl : in STD_LOGIC; -- 
					 TCPbuf_avl : in STD_LOGIC; -- 
					 buf_rqst	: out STD_LOGIC_VECTOR (3 downto 0);
--	ipbus signals
					 ipb_write : in  STD_LOGIC;
					 ipb_strobe : in  STD_LOGIC;
					 ipb_addr	: in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_wdata : in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_rdata : out  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_ack : out  STD_LOGIC;
-- TTC & TTS signals
					 TTC_clk : in   std_logic;
					 TTC_LOS : in   std_logic;
					 BC0 : in  std_logic;
					 bcnt : in std_logic_vector(3 downto 0);
					 TTS_disable : in std_logic_vector(11 downto 0);
					 ttc_evcnt_reset : in std_logic;
					 event_number_avl : in std_logic;
					 event_number : in std_logic_vector(59 downto 0);
					 evn_buf_full : out std_logic;
					 ovfl_warning : out std_logic;
					 TrigData	: out  array12x8;
					 TTS_coded : out  std_logic_vector(4 downto 0)
					);
end AMC_if;

architecture Behavioral of AMC_if is
COMPONENT fake_event
	PORT(
		sysclk : IN std_logic;
		UsrClk : IN std_logic;
		reset : IN std_logic;
		fifo_rst : IN std_logic;
		fifo_en : IN std_logic;
		sync : IN std_logic;
    LinkFull : in  STD_LOGIC;
		fake_en : IN std_logic;
		ovfl_warning : in  STD_LOGIC;
		fake_length	: in   std_logic_vector(17 downto 0);
		L1A_DATA : IN std_logic_vector(15 downto 0);
		L1A_WrEn : IN std_logic;          
		fake_header : OUT std_logic;
		fake_CRC : OUT std_logic;
		empty_event_flag : out  STD_LOGIC;
		fake_DATA : OUT std_logic_vector(15 downto 0);
		fake_WrEn : OUT std_logic
		);
END COMPONENT;
COMPONENT AMC_Link
	generic(N : integer := 14; useTRIG : boolean := false; simulation : boolean := false); -- M controls FIFO size, N controls timeout
	PORT(
		sysclk : IN std_logic;
		reset : IN std_logic;
		resetCntr : IN std_logic;
		ReSync : IN std_logic;
    fifo_rst                            : in   std_logic;
    fifo_en		                          : in   std_logic;
		test : IN std_logic;
		UsrClk : IN std_logic;
		AMC_ID : IN std_logic_vector(3 downto 0);
    txfsmresetdone	                 		: in   std_logic;
    RxResetDone	                    		: in   std_logic;
    qpll_lock	                       		: in   std_logic;
    rxcommaalignen                 			: out  std_logic;
    DATA_VALID                     			: out  std_logic;
    RXDATA		                      		: in   std_logic_vector(15 downto 0);
    RXCHARISCOMMA                     	: in   std_logic_vector(1 downto 0);
    RXCHARISK		                      	: in   std_logic_vector(1 downto 0);
    RXNOTINTABLE                      	: in   std_logic_vector(1 downto 0);
    TXDATA     	                    		: out  std_logic_vector(15 downto 0);
    TXCHARISK                        		: out  std_logic_vector(1 downto 0);
		AMC_en : IN std_logic;
		TTS_disable : IN std_logic;
		AMC_DATA_RdEn : IN std_logic;
		EventInfoRdDone : IN std_logic;
		L1A_DATA : IN std_logic_vector(15 downto 0);
		L1A_WrEn : IN std_logic;
		fake_header : IN std_logic;
		fake_CRC : IN std_logic;
		fake_DATA : IN std_logic_vector(15 downto 0);
		fake_WrEn : IN std_logic;
		fake_full : OUT std_logic;
		Cntr_RdEn : IN std_logic;
		Cntr_str : IN std_logic;
		ipb_addr : IN std_logic_vector(15 downto 0);
		TTCclk : IN std_logic;
		BC0 : IN std_logic;
		bcnt : IN std_logic_vector(3 downto 0);
		TTC_LOS : IN std_logic;          
		Ready : OUT std_logic;
		AMCinfo : OUT std_logic_vector(15 downto 0);
		EventInfo : OUT std_logic_vector(31 downto 0);
		EventInfo_dav : OUT std_logic;
		AMC_DATA : OUT std_logic_vector(63 downto 0);
		bad_AMC : OUT std_logic;
		AMC_OK : OUT std_logic;
		Cntr_DATA : OUT std_logic_vector(15 downto 0);
		ipb_rdata : OUT std_logic_vector(31 downto 0);
		debug_out : OUT std_logic_vector(255 downto 0);
		TTC_status : OUT std_logic_vector(127 downto 0);
		TrigData : OUT std_logic_vector(7 downto 0);
		TTS_coded : OUT std_logic_vector(7 downto 0)
		);
END COMPONENT;
COMPONENT AMC_wrapper
    Port ( DRPclk : in  STD_LOGIC;
           SOFT_RESET : in  STD_LOGIC;
           UsrClk : in  STD_LOGIC;
           test : in  STD_LOGIC;
           Dis_pd : in  STD_LOGIC;
           AMC_en : in  STD_LOGIC_VECTOR(11 downto 0);
					 RXDATA : out array12X16;
           rxprbserr : out  STD_LOGIC_VECTOR(11 downto 0);
					 rxprbssel : in array12X3;
           RXNOTINTABLE : out  array12X2;
           rxcommaalignen : in  STD_LOGIC_VECTOR(11 downto 0);
					 rxchariscomma : out array12X2;
					 rxcharisk : out array12X2;
           rxresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
					 txdiffctrl : in array12X4;
					 TXDATA : in array12X16;
           txoutclk : out  STD_LOGIC_VECTOR(11 downto 0);
					 txcharisk : in array12X2;
           txresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
					 txprbssel : in array12X3;
           qpll_lock : out  STD_LOGIC_VECTOR(2 downto 0);
           txfsmresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
           rxfsmresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
           data_valid : in  STD_LOGIC_VECTOR(11 downto 0);
           AMC_REFCLK : in  STD_LOGIC;
           RXN : in  STD_LOGIC_VECTOR(11 downto 0);
           RXP : in  STD_LOGIC_VECTOR(11 downto 0);
           TXN : out  STD_LOGIC_VECTOR(11 downto 0);
           TXP : out  STD_LOGIC_VECTOR(11 downto 0)
					 );
END COMPONENT;
COMPONENT evt_bldr
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		fifo_rst : IN std_logic;
		fifo_en : IN std_logic;
		OneSFP : IN std_logic;
		Source_ID : IN std_logic_vector(7 downto 0);
		block_wc : in  STD_LOGIC_VECTOR (15 downto 0);
		block_wc_we : in STD_LOGIC;
		AMC_wc : IN std_logic_vector(17 downto 0);
		AMC_wc_we : IN std_logic;
		AMC_wc_end : IN std_logic;
		AMC_header : IN std_logic_vector(65 downto 0);
		AMC_header_we : IN std_logic;
		AMC_DATA : IN array12X64;
		evt_buf_full : IN std_logic;
		evt_data_re : IN std_logic;          
		bldr_fifo_full : OUT std_logic;
		AMC_DATA_re : OUT std_logic_vector(11 downto 0);
		evt_data : OUT std_logic_vector(66 downto 0);
		evt_data_we : OUT std_logic;
		evt_data_rdy : OUT std_logic;
		debug : out  STD_LOGIC_VECTOR (255 downto 0);
		EventBuilt : OUT std_logic
		);
END COMPONENT;
COMPONENT cmsCRC64
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		data_in : IN std_logic_vector(63 downto 0);
		ctrl_in : IN std_logic;
		we_in : IN std_logic;          
		crc : OUT std_logic_vector(15 downto 0);
		crc_err : OUT std_logic;
		data_out : OUT std_logic_vector(63 downto 0);
		ctrl_out : OUT std_logic;
		we_out : OUT std_logic
		);
END COMPONENT;
COMPONENT FIFO_RESET_7S
	PORT(
		reset : IN std_logic;
		clk : IN std_logic;          
		fifo_rst : OUT std_logic;
		fifo_en : OUT std_logic
		);
END COMPONENT;
COMPONENT RAM32x6Db
	PORT(
		wclk : IN std_logic;
		di : IN std_logic_vector(5 downto 0);
		we : IN std_logic;
		wa : IN std_logic_vector(4 downto 0);
		ra : IN std_logic_vector(4 downto 0);          
		do : OUT std_logic_vector(5 downto 0)
		);
END COMPONENT;
type array_x12y256 is array(11 downto 0) of std_logic_vector(255 downto 0);
type array_x12y16 is array(11 downto 0) of std_logic_vector(15 downto 0);
type array_x12y32 is array(11 downto 0) of std_logic_vector(31 downto 0);
type array_x12y8 is array(11 downto 0) of std_logic_vector(7 downto 0);
type array_x12y5 is array(11 downto 0) of std_logic_vector(4 downto 0);
type array_x12y128 is array(11 downto 0) of std_logic_vector(127 downto 0);
constant AMC_ID : array12x4 := (x"1",x"2",x"3",x"4",x"5",x"6",x"7",x"8",x"9",x"a",x"b",x"c");
constant AMC_txdiffctrl : array12x4 := (others => x"b");
constant uFOV : std_logic_vector(3 downto 0) := x"1";
signal kAMC : array2x4 := (others => (others => '0'));
signal mAMC : array3x4 := (others => (others => '0'));
signal nAMC : array3x4 := (others => (others => '0'));
signal EventInfo : array_x12y32 := (others => (others => '0'));
signal AMCinfo : array12X16 := (others => (others => '0'));
signal AMC_DATA : array12X64 := (others => (others => '0'));
signal AMC_DATA1 : array12X64 := (others => (others => '0'));
signal AMC_DATA2 : array12X64 := (others => (others => '0'));
signal Cntr_DATA : array_x12y16 := (others => (others => '0'));
--signal AMC_TrigData : array_x12y8;
signal AMC_TTS : array_x12y8 := (others => (others => '0'));
signal AMC_debug : array_x12y256 := (others => (others => '0'));
signal TTC_status : array_x12y128 := (others => (others => '0'));
signal EventInfo_dav : std_logic_vector(11 downto 0);
--signal EventInfo_dav_n : std_logic_vector(11 downto 0);
signal EventInfoRdDone : std_logic_vector(12 downto 0) := (others => '0');
signal AMC_DATA_RdEn : std_logic_vector(11 downto 0) := (others => '0');
signal Cntr_RdEn : std_logic_vector(11 downto 0) := (others => '0');
signal ipb_strobe_q : std_logic := '0';
signal CounterDoB_h : std_logic := '0';
signal Cntr_str : std_logic := '0';
signal UsrClk : std_logic := '0';
signal UsrClk_out : std_logic_vector(11 downto 0) := (others => '0');
signal counter_we_H : std_logic_vector(3 downto 0) := (others => '0');
signal counter_we_L : std_logic_vector(1 downto 0) := (others => '0');
signal counter_wa : std_logic_vector(9 downto 0) := (others => '0');
signal CounterDi : std_logic_vector(47 downto 0) := (others => '0');
signal CounterDoA : std_logic_vector(47 downto 0) := (others => '0');
signal CounterDoB : std_logic_vector(47 downto 0) := (others => '0');
signal resetCntr_SyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal resetSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal CntrRst : std_logic := '0';
signal CntrRstCycle : std_logic := '0';
signal div : std_logic_vector(11 downto 0) := (others => '0');
signal inc_div : std_logic_vector(11 downto 0) := (others => '0');
signal evn_out : std_logic_vector(59 downto 0) := (others => '0');
signal evn_wa : std_logic_vector(8 downto 0) := (others => '0');
signal evn_ra : std_logic_vector(8 downto 0) := (others => '0');
signal evn_cnt : array3x8 := (others => (others => '0'));
signal evn : std_logic_vector(23 downto 0) := (others => '0');
signal CDF_in : std_logic_vector(71 downto 0) := (others => '0');
signal CDF_out : std_logic_vector(71 downto 0) := (others => '0');
signal CDF_wa : std_logic_vector(8 downto 0) := (others => '0');
signal CDF_ra : std_logic_vector(8 downto 0) := (others => '0');
signal CDF_cnt : std_logic_vector(7 downto 0) := (others => '0');
signal empty_event_flag : std_logic := '0';
signal evn_buf_full_i : std_logic_vector(2 downto 0) := (others => '0');
signal ovfl_warning_i : std_logic_vector(3 downto 0) := (others => '0');
signal ovfl_warning_p : std_logic := '0';
signal header : std_logic := '0';
signal init_bldr : std_logic := '0';
signal CDF_header : std_logic := '0';
signal CDF_empty : std_logic := '0';
signal BlockHeader : std_logic := '0';
signal ec_sel_AMC : std_logic := '0';
signal sel_AMC : std_logic_vector(3 downto 0) := (others => '0');
signal LastBlock : std_logic := '0';
signal FirstBlock : std_logic_vector(2 downto 0) := (others => '0');
signal sel_CDF : std_logic := '0';
signal evn_empty : std_logic := '0';
signal sel_evn : std_logic_vector(1 downto 0) := (others => '0');
signal L1A_WrEn : std_logic := '0';
signal L1A_DATA : std_logic_vector(15 downto 0) := (others => '0');
signal EvtTy : std_logic_vector(3 downto 0) := (others => '0');
signal CalTy : std_logic_vector(3 downto 0) := (others => '0');
signal EventInfo_avl : std_logic := '0';
signal rst_init_bldr : std_logic := '0';
signal Builder_busy : std_logic_vector(2 downto 0) := (others => '0');
signal ec_CDF_ra : std_logic := '0';
signal summary : std_logic_vector(63 downto 0) := (others => '0');
signal AMC_TTC_status : std_logic_vector(31 downto 0) := (others => '0');
signal fake_en: std_logic := '0';
signal fake_DATA : std_logic_vector(15 downto 0) := (others => '0');
signal fake_header : std_logic := '0';
signal fake_CRC : std_logic := '0';
signal fake_WrEn : std_logic := '0';
signal fake_word_cnt : std_logic_vector(31 downto 0) := (others => '0');
signal fake_evt_cnt : std_logic_vector(31 downto 0) := (others => '0');
signal empty_evt_cnt : std_logic_vector(31 downto 0) := (others => '0');
signal fake_header_cnt: std_logic_vector(31 downto 0) := (others => '0');
signal EventBuilt : std_logic_vector(2 downto 0) := (others => '0');
signal EventBuiltToggle : std_logic_vector(2 downto 0) := (others => '0');
signal EventBuiltCnt : array3x16 := (others => (others => '0'));
signal EventBuiltToggleSyncRegs : array3x4 := (others => (others => '0'));
signal next_bldr : std_logic_vector(1 downto 0) := (others => '0');
signal AMC_wcp : array12x13 := (others => (others => '0'));
signal AMC_wc : std_logic_vector(17 downto 0) := (others => '0');
signal AMC_wc_we : std_logic_vector(2 downto 0) := (others => '0');
signal en_block_wc : std_logic_vector(2 downto 0) := (others => '0');
signal block_wc_we : std_logic_vector(2 downto 0) := (others => '0');
signal AMC_wc_mask : std_logic_vector(2 downto 0) := (others => '0');
signal AMC_header : array3x66 := (others => (others => '0'));
signal AMC_header_we : std_logic_vector(2 downto 0) := (others => '0');
signal bldr_fifo_full : std_logic_vector(2 downto 0) := (others => '0');
type array3X12 is array(0 to 2) of std_logic_vector(11 downto 0);
signal AMC_DATA_re : array3X12 := (others => (others => '0'));
signal AMC_hasData : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_hasData_l : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_REFCLK : std_logic := '0';
signal AMC_TTS_OR : std_logic_vector(7 downto 0) := (others =>'0');
signal AMC_qpll_lock : std_logic_vector(2 downto 0) := (others =>'0');
signal AMC_rxprbserr : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_rxcommaalignen : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_rxresetdone : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_txfsmresetdone : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_rxfsmresetdone : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_data_valid : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_RXDATA : array12x16 := (others => (others => '0'));
signal AMC_TXDATA : array12x16 := (others => (others => '0'));
signal AMC_RXNOTINTABLE : array12x2 := (others => (others => '0'));
signal AMC_rxchariscomma : array12x2 := (others => (others => '0'));
signal AMC_rxcharisk : array12x2 := (others => (others => '0'));
signal AMC_txcharisk : array12x2 := (others => (others => '0'));
signal AMC_rxprbssel : array12x3 := (others => (others => '0'));
signal AMC_txprbssel : array12x3 := (others => (others => '0'));
type array3X4 is array(0 to 2) of std_logic_vector(3 downto 0);
signal AMC_rdata : array12x32 := (others => (others => '0'));
signal channel : array3X4 := (others => (others => '0'));
-- monitor signals
signal mon_wc: array3X16 := (others => (others => '0'));
signal mon_en: std_logic := '0';
signal scale_cntr : std_logic_vector(15 downto 0) := (others => '0');
signal ce_scale : std_logic := '0';
signal ld_scale : std_logic := '0';
signal MonBufAbort: std_logic := '0';
signal rst_mon_wc: std_logic := '0';
signal ce_wc_reg_wa: std_logic := '0';
signal wc_reg_wa: std_logic_vector(9 downto 0) := (others => '0');
signal start_wc_reg_wa: std_logic_vector(9 downto 0) := (others => '0');
signal down_count : std_logic := '0';
signal mon_mask: std_logic_vector(19 downto 0) := (others => '0');
signal sample_event: std_logic := '0';
signal scale : std_logic_vector(31 downto 0) := (others => '0');
signal pending : std_logic := '0';
signal AMC_Ready_i : std_logic_vector(11 downto 0);
signal AMC_OK : std_logic_vector(11 downto 0);
signal block_num : std_logic_vector(11 downto 0) := (others => '0');
signal resetFIFO : std_logic := '0';
signal fifo_rst : std_logic := '0';
signal fifo_en : std_logic := '0';
signal OneSFP : std_logic := '0';
signal TwoSFP : std_logic := '0';
signal ThreeSFP : std_logic := '0';
signal fake_full : std_logic_vector(11 downto 0) := (others => '0');
signal LinkFull : std_logic := '0';
signal EventInSlink : array3x4 := (others => (others => '0'));
signal TTS_FIFO_do : std_logic_vector(5 downto 0) := (others => '0');
signal TTS_FIFO_di : std_logic_vector(5 downto 0) := (others => '0');
signal TTS_FIFO_wa : std_logic_vector(4 downto 0) := (others => '0');
signal TTS_FIFO_ra : std_logic_vector(4 downto 0) := (others => '0');
signal TTS_FIFO_waSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal TTS_FIFO_waSyncRegs2 : std_logic_vector(2 downto 0) := (others => '0');
signal TTS_FIFO_waSyncRegs3 : std_logic_vector(2 downto 0) := (others => '0');
signal evt_bldr_debug : STD_LOGIC_VECTOR(255 DOWNTO 0);
component icon2
  PORT (
    CONTROL0 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL1 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0));

end component;
component ila128x4096
  PORT (
    CONTROL : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CLK : IN STD_LOGIC;
    DATA : IN STD_LOGIC_VECTOR(143 DOWNTO 0);
    TRIG0 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    TRIG1 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    TRIG2 : IN STD_LOGIC_VECTOR(7 DOWNTO 0));

end component;
signal CONTROL0 : STD_LOGIC_VECTOR(35 DOWNTO 0);
signal CONTROL1 : STD_LOGIC_VECTOR(35 DOWNTO 0);
signal DATA0 : STD_LOGIC_VECTOR(143 DOWNTO 0);
signal TRIG0 : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal TRIG1 : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal TRIG2 : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal DATA1 : STD_LOGIC_VECTOR(143 DOWNTO 0);
signal TRIG0b : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal TRIG1b : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal TRIG2b : STD_LOGIC_VECTOR(7 DOWNTO 0);
component chipscope1
		generic (N : integer := 2);
    Port ( clk : in  STD_LOGIC;
           Din : in  STD_LOGIC_VECTOR (303 downto 0));
end component;
signal CS : STD_LOGIC_VECTOR(303 DOWNTO 0) := (others => '0');
begin
--i_chipscope : chipscope1 port map(clk => TTC_clk, Din => cs);
--cs(288) <= BC0;
--cs(127 downto 0) <= TTC_status(6);
--cs(303 downto 296) <= cs(212) & cs(210 downto 204);
--cs(295 downto 288) <= cs(147) & cs(145 downto 139);
--cs(295 downto 288) <= AMC_debug(0)(80) & AMC_debug(0)(62 downto 56);
--cs(288) <= AMC_debug(4)(82);
--cs(287) <= sel_CDF;
--cs(264 downto 183) <= AMC_debug(4)(81 downto 0);
--cs(182 downto 0) <= evt_bldr_debug(182 downto 0);
--i_icon : icon2
--  port map (
--    CONTROL0 => CONTROL0,
--    CONTROL1 => CONTROL1);
--i_ila : ila128x4096
--      port map (
--        CONTROL => CONTROL0,
--        CLK => UsrClk,
--        DATA => DATA0,
--        TRIG0 => TRIG0,
--        TRIG1 => x"00",
--        TRIG2 => x"00");
--DATA0(3 downto 0) <= TTC_status(10)(84 downto 81);
--DATA0(16 downto 4) <= TTC_status(10)(18 downto 6);
--DATA0(44 downto 17) <= TTC_status(10)(118 downto 91);
--DATA0(46 downto 45) <= AMC_rxchariscomma(10);
--DATA0(48 downto 47) <= AMC_rxcharisk(10);
--DATA0(64 downto 49) <= AMC_RXDATA(10);
--DATA0(66 downto 65) <= TTC_status(10)(53 downto 52);
--DATA0(70 downto 67) <= TTC_status(9)(84 downto 81);
--DATA0(83 downto 71) <= TTC_status(9)(18 downto 6);
--DATA0(85 downto 84) <= TTC_status(9)(53 downto 52);
--DATA0(87 downto 86) <= AMC_rxchariscomma(9);
--DATA0(89 downto 88) <= AMC_rxcharisk(9);
--DATA0(105 downto 90) <= AMC_RXDATA(9);
--DATA0(109 downto 106) <= TTC_status(1)(84 downto 81);
--DATA0(122 downto 110) <= TTC_status(1)(18 downto 6);
--DATA0(124 downto 123) <= TTC_status(1)(53 downto 52);
--DATA0(125) <= AMC_rxchariscomma(1)(0);
--DATA0(127 downto 126) <= AMC_rxcharisk(1);
--DATA0(143 downto 128) <= AMC_RXDATA(1);
--TRIG0(1 downto 0) <= TTC_status(10)(53 downto 52) ;
--TRIG0(3 downto 2) <= TTC_status(9)(53 downto 52) ;
--TRIG0(5 downto 4) <= TTC_status(1)(53 downto 52) ;
--TRIG0(7 downto 6) <= "00" ;
--i_ila_b : ila128x4096
--          port map (
--            CONTROL => CONTROL1,
--            CLK => TTC_clk,
--            DATA => DATA1,
--            TRIG0 => TRIG1,
--            TRIG1 => x"00",
--            TRIG2 => x"00");
--DATA1(0) <= BC0;
--DATA1(9 downto 1) <= TTC_status(10)(35 downto 27);
--DATA1(46 downto 10) <= TTC_status(10)(90 downto 54);
--DATA1(55 downto 47) <= TTC_status(9)(35 downto 27);
--DATA1(92 downto 56) <= TTC_status(9)(90 downto 54);
--DATA1(101 downto 93) <= TTC_status(1)(35 downto 27);
--DATA1(138 downto 102) <= TTC_status(1)(90 downto 54);
--DATA1(142 downto 139) <= bcnt;
--TRIG1(0) <= BC0;
--TRIG1(2 downto 1) <= TTC_status(10)(31 downto 30);
--TRIG1(4 downto 3) <= TTC_status(9)(31 downto 30);
--TRIG1(6 downto 5) <= TTC_status(1)(31 downto 30);
--TRIG1(7) <= '0';
AMC_Ready <= AMC_Ready_i;
mon_ctrl <= scale;
process(sysclk,reset)
begin
	if(reset = '1')then
		resetSyncRegs <= (others => '1');
	elsif(sysclk'event and sysclk = '1')then
		resetSyncRegs <= resetSyncRegs(1 downto 0) & '0';
	end if;
end process;
-- receiving L1 information
ovfl_warning <= ovfl_warning_i(3);
i_evn : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 60,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 60,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
      WRITE_MODE => "WRITE_FIRST", -- Specify "READ_FIRST" for same clock or synchronous clocks
                                   --  Specify "WRITE_FIRST for asynchrononous clocks on ports
      INIT => X"000000000000000000") --  Initial values on output port
   port map (
      DO => evn_out,         -- Output read data port, width defined by READ_WIDTH parameter
      DI => event_number,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => evn_ra, -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => x"ff",         -- Input write enable, width defined by write port depth
      WRADDR => evn_wa, -- Input write address, width defined by write port depth
      WRCLK => sysclk,   -- 1-bit input write clock
      WREN => event_number_avl      -- 1-bit input write port enable
   );
process(sysclk)
variable enable : std_logic_vector(2 downto 0);
begin
	if(ThreeSFP = '1')then
		enable := "111";
	elsif(TwoSFP = '1')then
		enable := "011";
	else
		enable := "001";
	end if;
	if(sysclk'event and sysclk = '1')then
--		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1')then
		if(resetSyncRegs(2) = '1')then
			evn_wa <= (others => '0');
		elsif(event_number_avl = '1')then
			evn_wa <= evn_wa + 1;
		end if;
--		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1')then
--			evn <= x"000001";
--			evn_ra <= (others => '0');
--		elsif(sel_evn = "10")then
--			evn <= evn + 1;
--			evn_ra <= evn_ra + 1;
--		end if;
		if(resetSyncRegs(2) = '1')then
			evn_ra <= (others => '0');
		elsif(sel_evn = "10")then
			evn_ra <= evn_ra + 1;
		end if;
		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1')then
			evn <= x"000001";
		elsif(sel_evn = "10")then
			evn <= evn + 1;
		end if;
		for i in 0 to 2 loop
--			if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1' or enable(i) = '0')then
			if(resetSyncRegs(2) = '1' or enable(i) = '0')then
				evn_cnt(i) <= (others => '0');
			elsif(event_number_avl = '1' and EventBuilt(i) = '0')then
				evn_cnt(i) <= evn_cnt(i) + 1;
			elsif(event_number_avl = '0' and EventBuilt(i) = '1')then
				evn_cnt(i) <= evn_cnt(i) - 1;
			end if;
			if(and_reduce(evn_cnt(i)(7 downto 5)) = '1')then
				evn_buf_full_i(i) <= '1';
			else
				evn_buf_full_i(i) <= '0';
			end if;
	-- when reached 0x60, throttle L1A. Return only after go below 0x40
			if(or_reduce(evn_cnt(i)(7 downto 6)) = '0')then
				ovfl_warning_i(i) <= '0';
			elsif(evn_cnt(i)(5) = '1')then
				ovfl_warning_i(i) <= '1';
			end if;
		end loop;
		evn_buf_full <= or_reduce(evn_buf_full_i);
		ovfl_warning_i(3) <= or_reduce(ovfl_warning_i(2 downto 0)) or (or_reduce(TTS_FIFO_do(4 downto 0)) and en_localL1A);
	end if;
end process;
-- send L1info to AMC_Link
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
--		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1' or evn_wa = evn_ra)then
		if(resetSyncRegs(2) = '1' or evn_wa = evn_ra)then
			evn_empty <= '1';
		else
			evn_empty <= '0';
		end if;
		L1A_WrEn <= not evn_empty;
--		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1' or evn_empty = '1')then
		if(resetSyncRegs(2) = '1' or evn_empty = '1')then
			sel_evn <= "00";
		else
			sel_evn(1) <= sel_evn(1) xor sel_evn(0);
			sel_evn(0) <= not sel_evn(0);
		end if;
		case sel_evn is
			when "00" => L1A_DATA <= evn_out(11 downto 0) & x"0"; -- BX
			when "01" => L1A_DATA <= evn(15 downto 0);
			when "10" => L1A_DATA <= x"00" & evn(23 downto 16);
			when others => L1A_DATA <= evn_out(27 downto 12); -- OrN
		end case;
	end if;
end process;
i_CDF : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 72,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 72,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
      WRITE_MODE => "WRITE_FIRST", -- Specify "READ_FIRST" for same clock or synchronous clocks
                                   --  Specify "WRITE_FIRST for asynchrononous clocks on ports
      INIT => X"000000000000000000") --  Initial values on output port
   port map (
      DO => CDF_out,         -- Output read data port, width defined by READ_WIDTH parameter
      DI => CDF_in,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => CDF_ra, -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => x"ff",         -- Input write enable, width defined by write port depth
      WRADDR => CDF_wa, -- Input write address, width defined by write port depth
      WRCLK => sysclk,   -- 1-bit input write clock
      WREN => sel_evn(0)      -- 1-bit input write port enable
   );
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
--		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1')then
		if(resetSyncRegs(2) = '1')then
			CDF_wa <= (others => '0');
		elsif(sel_evn(0) = '1')then
			CDF_wa <= CDF_wa + 1;
		end if;
--		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1')then
		if(resetSyncRegs(2) = '1')then
			CDF_ra <= (others => '0');
		elsif(ec_CDF_ra = '1')then
			CDF_ra <= CDF_ra + 1;
		end if;
		if(resetSyncRegs(2) = '1')then
      CDF_cnt <= (others => '0');
    elsif(sel_evn(0) = '1' and CDF_wa(0) = '1' and (ec_CDF_ra = '0' or CDF_ra(0) = '1'))then
      CDF_cnt <= CDF_cnt + 1;
    elsif((sel_evn(0) = '0' or CDF_wa(0) = '0') and ec_CDF_ra = '1' and CDF_ra(0) = '0')then
      CDF_cnt <= CDF_cnt - 1;
    end if;
		if(resetSyncRegs(2) = '1')then
      CDF_empty <= '1';
    elsif(or_reduce(CDF_cnt(7 downto 1)) = '0' and (CDF_cnt(0) = '0' or ec_CDF_ra = '1'))then
      CDF_empty <= '1';
    elsif(or_reduce(CDF_cnt) = '1')then
      CDF_empty <= '0';
    end if;
		if(sel_evn(1) = '0')then
			CDF_in <= x"005" & EvtTy & evn & evn_out(11 downto 0) & Source_ID(11 downto 0) & x"08"; -- header1
		else
			CDF_in <= x"00" & uFOV & CalTy & x"00000" & evn_out(43 downto 12) & x"0"; -- header2
		end if;
	end if;
end process;
EvtTy <= "00" & evn_out(45) & not evn_out(45);
CalTy <= evn_out(51 downto 48);
process(sysclk, ThreeSFP, TwoSFP, sel_AMC)
variable bldr_mask_sel : std_logic_vector(4 downto 0);
variable bldr_mask : std_logic_vector(2 downto 0);
variable Mbit_word : std_logic_vector(11 downto 0);
begin
	bldr_mask_sel(4) := ThreeSFP; 
	bldr_mask_sel(3) := TwoSFP; 
	bldr_mask_sel(2 downto 0) := sel_AMC(3 downto 1);
	case bldr_mask_sel is
		when "10100" | "10101" => bldr_mask := "100";
		when "10000" | "10001" | "01000" | "01001" | "01010" => bldr_mask := "010";
		when others => bldr_mask := "001";
	end case;
	for i in 0 to 11 loop
		Mbit_word(i) := EventInfo(i)(25);
	end loop;
	if(sysclk'event and sysclk = '1')then
		if(resetSyncRegs(2) = '1')then
			CDF_header <= '1';
			header <= '0';
			init_bldr <= '0';
			EventInfo_avl <= '0';
			ec_sel_AMC <= '0';
			AMC_wc_we <= "000";
			BlockHeader <= '0';
			ec_CDF_ra <= '0';
			AMC_header_we <= "000";
			sel_CDF <= '0';
			buf_rqst <= x"0";
			sel_AMC <= x"0";
		else
			if((and_reduce(not AMC_hasData or EventInfo_dav) = '1' and or_reduce(AMC_hasData) = '1') or (or_reduce(amc_en) = '0' and CDF_empty = '0'))then
		    EventInfo_avl <= '1';
			else
		    EventInfo_avl <= '0';
			end if;
			if(EventInfo_avl = '1' and init_bldr = '0' and bldr_fifo_full = "000" and (((mon_en = '0' or WaitMonBuF = '0') and TCPbuf_avl = '1') or (mon_en = '1' and mon_buf_avl = '1')))then
				if(CDF_header = '1')then
					ec_CDF_ra <= '1';
				else
					BlockHeader <= '1';				
				end if;
				header <= '1';
				init_bldr <= '1';				
				buf_rqst <= LastBlock & CDF_header & not mon_en & mon_en;
				AMC_header(0)(64) <= mon_en and mon_buf_avl;
				AMC_header(1)(64) <= mon_en and mon_buf_avl;
				AMC_header(2)(64) <= mon_en and mon_buf_avl;
			elsif(rst_init_bldr = '1')then
				init_bldr <= '0';
				if(LastBlock = '1')then
					ec_CDF_ra <= '1';
					CDF_header <= '1';
				end if;
			else
				header <= '0';
				ec_CDF_ra <= '0';
				buf_rqst <= x"0";
				if(init_bldr = '1')then
					CDF_header <= '0';
					BlockHeader <= CDF_header;
				end if;
			end if;
			sel_CDF <= (CDF_header and init_bldr) or BlockHeader;
			if(BlockHeader = '1')then
				AMC_hasData_l <= AMC_hasData;
			end if;
			if(BlockHeader = '1')then
				ec_sel_AMC <= '1';
			elsif(sel_AMC = x"b")then
				ec_sel_AMC <= '0';
			end if;
			if(AMC_hasData(conv_integer(sel_AMC)) = '1' and ec_sel_AMC = '1')then
				AMC_wc_we <= bldr_mask; 
			else
				AMC_wc_we <= "000"; 
			end if;
			for i in 0 to 2 loop
				if((sel_CDF = '1' and (FirstBlock(i) = '1' or nAMC(i) /= x"0")) or AMC_wc_we(i) = '1')then
					AMC_header_we(i) <= '1';
				else
					AMC_header_we(i) <= '0';
				end if;
			end loop;
			if(ec_sel_AMC = '0' or sel_AMC = x"b")then
				sel_AMC <= x"0";
			else
				sel_AMC <= sel_AMC + 1;
			end if;
		end if;
		for i in 0 to 2 loop
			case AMC_hasData(i*4+3 downto i*4) is
				when x"1" | x"2" | x"4" | x"8" => mAMC(i) <= x"1";
				when x"3" | x"5" | x"6" | x"9" | x"a" | x"c" => mAMC(i) <= x"2";
				when x"7" | x"b" | x"d" | x"e" => mAMC(i) <= x"3";
				when x"f" => mAMC(i) <= x"4";
				when others => mAMC(i) <= x"0";
			end case;
		end loop;
		kAMC(0)(1) <= AMC_hasData(5) and AMC_hasData(4);
		kAMC(0)(0) <= AMC_hasData(5) xor AMC_hasData(4);
		kAMC(1)(1) <= AMC_hasData(7) and AMC_hasData(6);
		kAMC(1)(0) <= AMC_hasData(7) xor AMC_hasData(6);
		if(ThreeSFP = '1')then
			nAMC(0) <= mAMC(1);
		elsif(TwoSFP = '1')then
			nAMC(0) <= mAMC(2) + kAMC(1);
		else
			nAMC(0) <= mAMC(0) + mAMC(1) + mAMC(2);
		end if;
		if(ThreeSFP = '1')then
			nAMC(1) <= mAMC(0);
		elsif(TwoSFP = '1')then
			nAMC(1) <= mAMC(0) + kAMC(0);
		else
			nAMC(1) <= x"0";
		end if;
		if(ThreeSFP = '1')then
			nAMC(2) <= mAMC(2);
		else
			nAMC(2) <= x"0";
		end if;
		summary <= '0' & EventInfo(conv_integer(sel_AMC))(26 downto 20) & x"0" & EventInfo(conv_integer(sel_AMC))(19 downto 0) & block_num & (sel_AMC+1) & AMCinfo(conv_integer(sel_AMC));
		for i in 0 to 2 loop
			AMC_header(i)(65) <= not BlockHeader and sel_CDF;
			if(sel_CDF = '0')then
				AMC_header(i)(55 downto 52) <= summary(55 downto 52);
			elsif(BlockHeader = '1')then
				AMC_header(i)(55 downto 52) <= CDF_out(55 downto 52);
			else
				AMC_header(i)(55 downto 52) <= nAMC(i);
			end if;
			if(sel_CDF = '1')then
				AMC_header(i)(63 downto 56) <= CDF_out(63 downto 56);
				AMC_header(i)(51 downto 0) <= CDF_out(51 downto 0);
			else
				AMC_header(i)(63 downto 56) <= summary(63 downto 56);
				AMC_header(i)(51 downto 0) <= summary(51 downto 0);
			end if;
		end loop;
		LastBlock <= not or_reduce(AMC_hasData and Mbit_word);
		if(CDF_header = '1')then
			FirstBlock(0) <= '1';
			FirstBlock(1) <= TwoSFP or ThreeSFP;
			FirstBlock(2) <= ThreeSFP;
			block_num <= (others => '0');
		elsif(rst_init_bldr = '1')then
			FirstBlock <= "000";
			block_num <= block_num + 1;
		end if;
		if(fifo_en = '0' or (EventInfoRdDone(12) = '1' and LastBlock = '1'))then
			AMC_hasData <= AMC_en;
		elsif(ec_sel_AMC = '1' and EventInfo(conv_integer(sel_AMC))(25) = '0')then -- More bit is '0'
			AMC_hasData(conv_integer(sel_AMC)) <= '0';
		end if;
		for i in 0 to 11 loop
			if(Mbit_word(i) = '1')then
				AMC_wcp(i) <= "1000000000000"; 
			else
				AMC_wcp(i) <= EventInfo(i)(12 downto 0); 
			end if;
		end loop;
		AMC_wc <= LastBlock & sel_AMC & AMC_wcp(conv_integer(sel_AMC));
	end if;
end process;
kAMC(1)(3 downto 2) <= "00";
kAMC(0)(3 downto 2) <= "00";
--AMC_header(1)(64 downto 56) <= AMC_header(0)(64 downto 56);
--AMC_header(1)(51 downto 0) <= AMC_header(0)(51 downto 0);
--AMC_header(2)(64 downto 56) <= AMC_header(0)(64 downto 56);
--AMC_header(2)(51 downto 0) <= AMC_header(0)(51 downto 0);
i_evt_bldr0: evt_bldr PORT MAP(
		clk => sysclk,
		reset => resetSyncRegs(2),
		fifo_rst => fifo_rst,
		fifo_en => fifo_en,
		OneSFP => OneSFP,
		Source_ID => Source_ID(19 downto 12),
		block_wc => mon_wc(0),
		block_wc_we => block_wc_we(0),
		AMC_wc => AMC_wc,
		AMC_wc_we => AMC_wc_we(0),
		AMC_wc_end => rst_init_bldr,
		bldr_fifo_full => bldr_fifo_full(0),
		AMC_header => AMC_header(0),
		AMC_header_we => AMC_header_we(0),
		AMC_DATA => AMC_DATA,
		AMC_DATA_re => AMC_DATA_re(0),
		evt_data => evt_data(0),
		evt_data_we => evt_data_we(0),
		evt_buf_full => evt_buf_full(0),
		evt_data_re => evt_data_re(0),
		evt_data_rdy => evt_data_rdy(0),
		debug => evt_bldr_debug,
		EventBuilt => EventBuilt(0)
	);
i_evt_bldr1: evt_bldr PORT MAP(
		clk => sysclk,
		reset => resetSyncRegs(2),
		fifo_rst => fifo_rst,
		fifo_en => fifo_en,
		OneSFP => OneSFP,
		Source_ID => Source_ID(19 downto 12),
		block_wc => mon_wc(1),
		block_wc_we => block_wc_we(1),
		AMC_wc => AMC_wc,
		AMC_wc_we => AMC_wc_we(1),
		AMC_wc_end => rst_init_bldr,
		bldr_fifo_full => bldr_fifo_full(1),
		AMC_header => AMC_header(1),
		AMC_header_we => AMC_header_we(1),
		AMC_DATA => AMC_DATA1,
		AMC_DATA_re => AMC_DATA_re(1),
		evt_data => evt_data(1),
		evt_data_we => evt_data_we(1),
		evt_buf_full => evt_buf_full(1),
		evt_data_re => evt_data_re(1),
		evt_data_rdy => evt_data_rdy(1),
		debug => open,
		EventBuilt => EventBuilt(1)
	);
g_AMC_DATA1: for i in 0 to 5 generate
	AMC_DATA1(i) <= AMC_DATA(i);
	AMC_DATA1(i+6) <= (others => '0');
end generate;
i_evt_bldr2: evt_bldr PORT MAP(
		clk => sysclk,
		reset => resetSyncRegs(2),
		fifo_rst => fifo_rst,
		fifo_en => fifo_en,
		OneSFP => OneSFP,
		Source_ID => Source_ID(19 downto 12),
		block_wc => mon_wc(2),
		block_wc_we => block_wc_we(2),
		AMC_wc => AMC_wc,
		AMC_wc_we => AMC_wc_we(2),
		AMC_wc_end => rst_init_bldr,
		bldr_fifo_full => bldr_fifo_full(2),
		AMC_header => AMC_header(2),
		AMC_header_we => AMC_header_we(2),
		AMC_DATA => AMC_DATA2,
		AMC_DATA_re => AMC_DATA_re(2),
		evt_data => evt_data(2),
		evt_data_we => evt_data_we(2),
		evt_buf_full => evt_buf_full(2),
		evt_data_re => evt_data_re(2),
		evt_data_rdy => evt_data_rdy(2),
		debug => open,
		EventBuilt => EventBuilt(2)
	);
g_AMC_DATA2: for i in 0 to 3 generate
	AMC_DATA2(i) <= AMC_DATA(i+8);
	AMC_DATA2(i+4) <= AMC_DATA(i+8);
	AMC_DATA2(i+8) <= AMC_DATA(i+8);
end generate;
AMC_DATA_RdEn <= AMC_DATA_re(0) or AMC_DATA_re(1) or AMC_DATA_re(2);
g_AMC_Link : for i in 0 to 11 generate
	i_AMC_Link: AMC_Link
	generic map(useTRIG => AMC_useTRIG)
	PORT MAP(
		sysclk => sysclk,
		reset => resetSyncRegs(2),
		resetCntr => CntrRst,
		ReSync => ReSync,
		fifo_rst => fifo_rst,
		fifo_en => fifo_en,
		test => test,
		UsrClk => UsrClk,
		RXNOTINTABLE => AMC_RXNOTINTABLE(i),
		rxcommaalignen => AMC_rxcommaalignen(i),
		rxchariscomma => AMC_rxchariscomma(i),
		rxcharisk => AMC_rxcharisk(i),
		rxresetdone => AMC_rxresetdone(i),
		qpll_lock => AMC_qpll_lock(i/4),
		txfsmresetdone => AMC_txfsmresetdone(i),
		data_valid => AMC_data_valid(i),
		RXDATA => AMC_RXDATA(i),
		txcharisk => AMC_txcharisk(i),
		TXDATA => AMC_TXDATA(i),
		Ready => AMC_Ready_i(i),
		AMC_ID => AMC_ID(i),
		AMCinfo => AMCinfo(i),
		EventInfo => EventInfo(i),
		EventInfo_dav => EventInfo_dav(i),
		AMC_DATA_RdEn => AMC_DATA_RdEn(i),
		EventInfoRdDone => EventInfoRdDone(i),
		AMC_DATA => AMC_DATA(i),
		bad_AMC => AMC_status(i),
		AMC_OK => AMC_OK(i),
		L1A_DATA => L1A_DATA,
		L1A_WrEn => L1A_WrEn,
    fake_header => fake_header,
		fake_CRC => fake_CRC,
    fake_DATA	=> fake_DATA,
    fake_WrEn => fake_WrEn,
    fake_full => fake_full(i),
		Cntr_RdEn => Cntr_RdEn(i),
		Cntr_str => Cntr_str,
		Cntr_DATA => Cntr_DATA(i),
		ipb_addr => ipb_addr(15 downto 0),
		ipb_rdata => AMC_rdata(i),
		debug_out => AMC_debug(i),
		TTCclk => TTC_clk,
		BC0 => BC0,
		bcnt => bcnt,
		TTC_LOS => TTC_LOS,
		AMC_en => AMC_en(i),
		TTS_disable => TTS_disable(i),
		TTC_status => TTC_status(i),
		TrigData => TrigData(i),
		TTS_coded => AMC_TTS(i)
	);
end generate;
i_AMC_wrapper: AMC_wrapper PORT MAP(
		DRPclk => DRPclk,
		SOFT_RESET => GTXreset,
		UsrClk => UsrClk,
		test => test,
		Dis_pd => Dis_pd,
		AMC_en => AMC_en,
		RXDATA => AMC_RXDATA,
		rxprbserr => AMC_rxprbserr,
		rxprbssel => AMC_rxprbssel,
		RXNOTINTABLE => AMC_RXNOTINTABLE,
		rxcommaalignen => AMC_rxcommaalignen,
		rxchariscomma => AMC_rxchariscomma,
		rxcharisk => AMC_rxcharisk,
		rxresetdone => AMC_rxresetdone,
		txdiffctrl => AMC_txdiffctrl,
		TXDATA => AMC_TXDATA,
		txoutclk => UsrClk_out,
		txcharisk => AMC_txcharisk,
		txresetdone => open,
		txprbssel => AMC_txprbssel,
		qpll_lock => AMC_qpll_lock,
		txfsmresetdone => AMC_txfsmresetdone,
		rxfsmresetdone => AMC_rxfsmresetdone,
		data_valid => AMC_data_valid,
		AMC_REFCLK => AMC_REFCLK,
		RXN => AMC_RXN,
		RXP => AMC_RXP,
		TXN => AMC_TXN,
		TXP => AMC_TXP
	);
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		ovfl_warning_p <= ovfl_warning_i(3) and not en_localL1A;
		if(resetSyncRegs(2) = '1')then
			EventBuiltCnt <= (others => (others => '0'));
		else
			for i in 0 to 2 loop
				if(EventBuilt(i) = '1')then
					EventBuiltCnt(i) <= EventBuiltCnt(i) + 1;
				end if;
			end loop;
		end if;
	end if;
end process;
process(UsrClk)
begin
	if(UsrClk'event and UsrClk = '1')then
		LinkFull <= or_reduce(fake_full);
	end if;
end process;
fake_en <= '1' when test = '0' or AMC_en = x"000" else '1';
i_fake_event: fake_event PORT MAP(
		sysclk => sysclk,
		UsrClk => UsrClk,
		reset => resetSyncRegs(2),
		fifo_rst => fifo_rst,
		fifo_en => fifo_en,
		fake_en => fake_en,
		sync => '1',
		fake_length => fake_length,
		ovfl_warning => ovfl_warning_p,
		LinkFull => LinkFull,
		L1A_DATA => L1A_DATA,
		L1A_WrEn => L1A_WrEn,
		fake_header => fake_header,
		fake_CRC => fake_CRC,
		empty_event_flag => empty_event_flag,
		fake_DATA => fake_DATA,
		fake_WrEn => fake_WrEn
	);
process(UsrClk)
begin
	if(UsrClk'event and UsrClk = '1')then
		AMC_TTS_OR <= AMC_TTS(0) or AMC_TTS(1) or AMC_TTS(2) or AMC_TTS(3) or AMC_TTS(4) or AMC_TTS(5) or
									AMC_TTS(6) or AMC_TTS(7) or AMC_TTS(8) or AMC_TTS(9) or AMC_TTS(10) or AMC_TTS(11);
	end if;
end process;
process(UsrClk,reset)
begin
	if(reset = '1')then
		TTS_FIFO_wa <= (others => '0');
	elsif(UsrClk'event and UsrClk = '1')then
		case TTS_FIFO_wa(2 downto 0) is
			when "000" => TTS_FIFO_wa(2 downto 0) <= "001";
			when "001" => TTS_FIFO_wa(2 downto 0) <= "011";
			when "011" => TTS_FIFO_wa(2 downto 0) <= "010";
			when "010" => TTS_FIFO_wa(2 downto 0) <= "110";
			when "110" => TTS_FIFO_wa(2 downto 0) <= "111";
			when "111" => TTS_FIFO_wa(2 downto 0) <= "101";
			when "101" => TTS_FIFO_wa(2 downto 0) <= "100";
			when others => TTS_FIFO_wa(2 downto 0) <= "000";
		end case;
	end if;
end process;
i_TTS_FIFO: RAM32x6Db PORT MAP(
		wclk => UsrClk,
		di => TTS_FIFO_di,
		we => '1',
		wa => TTS_FIFO_wa,
		ra => TTS_FIFO_ra,
		do => TTS_FIFO_do
	);
TTS_FIFO_di(4 downto 0) <= AMC_TTS_OR(4 downto 0);
TTS_FIFO_ra <= "00" & TTS_FIFO_waSyncRegs3;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		TTS_FIFO_waSyncRegs <= TTS_FIFO_wa(2 downto 0);
		TTS_FIFO_waSyncRegs2 <= TTS_FIFO_waSyncRegs;
		TTS_FIFO_waSyncRegs3 <= TTS_FIFO_waSyncRegs2;
		TTS_coded <= TTS_FIFO_do(4 downto 0);
	end if;
end process;
i_UsrClk_buf: bufg port map(i => UsrClk_out(6), o => UsrClk);
i_counter_H : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      DOA_REG => 0, -- Optional port A output register (0 or 1)
      DOB_REG => 0, -- Optional port B output register (0 or 1)
      INIT_A => X"000000000", -- Initial values on A output port
      INIT_B => X"000000000", -- Initial values on B output port
      INIT_FILE => "NONE",
      READ_WIDTH_A => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE" 
      SRVAL_A => X"000000000",   -- Set/Reset value for A port output
      SRVAL_B => X"000000000",   -- Set/Reset value for B port output
      WRITE_MODE_A => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_MODE_B => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_WIDTH_A => 32, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 32) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => CounterDoA(47 downto 16),       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => CounterDoB(47 downto 16),       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => counter_wa,   -- Input port-A address, width defined by Port A depth
      ADDRB => ipb_addr(10 downto 1),   -- Input port-B address, width defined by Port B depth
      CLKA => UsrClk,     -- 1-bit input port-A clock
      CLKB => clk125,     -- 1-bit input port-B clock
      DIA => CounterDi(47 downto 16),       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => (others => '0'),       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => '1',       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => counter_we_H,       -- Input port-A write enable, width defined by Port A depth
      WEB => x"0"        -- Input port-B write enable, width defined by Port B depth
   );
counter_we_H <= x"f" when CntrRstCycle = '1' or (div(1 downto 0) = "10" and CounterDi(15 downto 0) < CounterDoA(15 downto 0)) else x"0";
i_counter_L : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "18Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      DOA_REG => 0, -- Optional port A output register (0 or 1)
      DOB_REG => 0, -- Optional port B output register (0 or 1)
      INIT_A => X"000000000", -- Initial values on A output port
      INIT_B => X"000000000", -- Initial values on B output port
      INIT_FILE => "NONE",
      READ_WIDTH_A => 16,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 16,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE" 
      SRVAL_A => X"000000000",   -- Set/Reset value for A port output
      SRVAL_B => X"000000000",   -- Set/Reset value for B port output
      WRITE_MODE_A => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_MODE_B => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_WIDTH_A => 16, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 16) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => CounterDoA(15 downto 0),       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => CounterDoB(15 downto 0),       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => counter_wa,   -- Input port-A address, width defined by Port A depth
      ADDRB => ipb_addr(10 downto 1),   -- Input port-B address, width defined by Port B depth
      CLKA => UsrClk,     -- 1-bit input port-A clock
      CLKB => clk125,     -- 1-bit input port-B clock
      DIA => CounterDi(15 downto 0),       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => (others => '0'),       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => '1',       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => counter_we_L,       -- Input port-A write enable, width defined by Port A depth
      WEB => "00"        -- Input port-B write enable, width defined by Port B depth
   );
counter_we_L <= "11" when Cntr_str = '1' else "00";
process(TTC_status, AMC_en)
begin
	for i in 0 to 11 loop
		AMC_TTC_status(i) <= TTC_status(i)(0) and AMC_en(i);
		AMC_TTC_status(i+16) <= TTC_status(i)(1) and AMC_en(i);
	end loop;
end process;
BC0_lock <= AMC_TTC_status(11 downto 0);
AMC_TTC_status(31 downto 28) <= x"0";
AMC_TTC_status(15 downto 12) <= x"0";
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		if(ipb_strobe = '1' and ipb_write = '1' and ipb_addr(14 downto 0) = MON_ctrl_addr(14 downto 0) and ipb_addr(27) = '0')then
			scale(23 downto 0) <= ipb_wdata(23 downto 0);
		end if;
		ipb_strobe_q <= ipb_strobe;
	end if;
end process;
ipb_ack <= '0' when ipb_addr(27) = '1' or ipb_addr(15 downto 11) /= AMC_reg_addr(15 downto 11) or ipb_write = '1' else ipb_strobe;
process(ipb_addr)
begin
	if(ipb_addr(15 downto 11) /= AMC_reg_addr(15 downto 11))then
		ipb_rdata <= (others => '0');
	elsif(ipb_addr(10 downto 9) = "11")then
		case ipb_addr(7 downto 4) is
			when x"0" =>
				case ipb_addr(3 downto 0) is
					when x"0" => ipb_rdata <= EventInfo(0);
					when x"1" => ipb_rdata <= EventInfo(1);
					when x"2" => ipb_rdata <= EventInfo(2);
					when x"3" => ipb_rdata <= EventInfo(3);
					when x"4" => ipb_rdata <= EventInfo(4);
					when x"5" => ipb_rdata <= EventInfo(5);
					when x"6" => ipb_rdata <= EventInfo(6);
					when x"7" => ipb_rdata <= EventInfo(7);
					when x"8" => ipb_rdata <= EventInfo(8);
					when x"9" => ipb_rdata <= EventInfo(9);
					when x"a" => ipb_rdata <= EventInfo(10);
					when x"b" => ipb_rdata <= EventInfo(11);
					when x"c" => ipb_rdata <= x"0" & fake_full & LinkFull & not AMC_qpll_lock & EventInfo_dav;
					when x"d" => ipb_rdata <= AMC_TTC_status;
					when x"e" => ipb_rdata <= x"0" & AMC_txfsmresetdone & x"0" & AMC_rxfsmresetdone;
					when others => ipb_rdata <= x"00000" & "000" & CDF_empty & CDF_cnt;
				end case;
			when x"1" =>
				case ipb_addr(3 downto 0) is
					when x"0" => ipb_rdata <= "0000000" & evn_ra & "0000000" & evn_wa;
					when x"1" => ipb_rdata <= x"00" & evn;
					when x"2" => ipb_rdata <= "0000000" & CDF_ra & "0000000" & CDF_wa;
					when x"3" => ipb_rdata <= "000000" & mon_en & WaitMonBuF & TCPbuf_avl & mon_buf_avl & init_bldr & evn_empty & EventInfo_avl & bldr_fifo_full & ec_CDF_ra & AMC_wc_we & sel_CDF & AMC_header_we & sel_evn & "00" & sel_AMC;
					when x"4" => ipb_rdata <= fake_word_cnt;
					when x"5" => ipb_rdata <= fake_header_cnt;
					when x"6" => ipb_rdata <= fake_evt_cnt;
					when x"7" => ipb_rdata <= empty_evt_cnt;
					when x"8" => ipb_rdata <= TTC_status(7)(5 downto 2) & TTC_status(6)(5 downto 2) & TTC_status(5)(5 downto 2) & TTC_status(4)(5 downto 2) & TTC_status(3)(5 downto 2) & TTC_status(2)(5 downto 2) & TTC_status(1)(5 downto 2) & TTC_status(0)(5 downto 2);
					when x"9" => ipb_rdata <= x"0000" & TTC_status(11)(5 downto 2) & TTC_status(10)(5 downto 2) & TTC_status(9)(5 downto 2) & TTC_status(8)(5 downto 2);
					when x"a" => ipb_rdata <= AMC_TTS(3) & AMC_TTS(2) & AMC_TTS(1) & AMC_TTS(0);
					when x"b" => ipb_rdata <= AMC_TTS(7) & AMC_TTS(6) & AMC_TTS(5) & AMC_TTS(4);
					when x"c" => ipb_rdata <= AMC_TTS(11) & AMC_TTS(10) & AMC_TTS(9) & AMC_TTS(8);
					when x"d" => ipb_rdata <= evt_bldr_debug(31 downto 0);
					when x"e" => ipb_rdata <= evt_bldr_debug(63 downto 32);
					when x"f" => ipb_rdata <= evt_bldr_debug(95 downto 64);
					when others => ipb_rdata <= (others => '0');
				end case;
			when x"4" => ipb_rdata <= AMC_rdata(0);
			when x"5" => ipb_rdata <= AMC_rdata(1);
			when x"6" => ipb_rdata <= AMC_rdata(2);
			when x"7" => ipb_rdata <= AMC_rdata(3);
			when x"8" => ipb_rdata <= AMC_rdata(4);
			when x"9" => ipb_rdata <= AMC_rdata(5);
			when x"a" => ipb_rdata <= AMC_rdata(6);
			when x"b" => ipb_rdata <= AMC_rdata(7);
			when x"c" => ipb_rdata <= AMC_rdata(8);
			when x"d" => ipb_rdata <= AMC_rdata(9);
			when x"e" => ipb_rdata <= AMC_rdata(10);
			when x"f" => ipb_rdata <= AMC_rdata(11);
			when others => ipb_rdata <= (others => '0');
		end case;
	elsif(ipb_addr(0) = '0')then
		ipb_rdata <= CounterDoB(31 downto 0);
	else
		ipb_rdata <= x"0000" & CounterDoB(47 downto 32);
	end if;
end process;
--EventInfo_dav_n <= not EventInfo_dav and AMC_en;
AMC_status(31 downto 28) <= (others => '0');
AMC_status(27 downto 16) <= AMC_data_valid or not AMC_en;
AMC_status(15 downto 12) <= (others => '0');
inc_div <= x"004" when CntrRstCycle = '1' else x"001";
process(UsrClk, Cntr_Data)
variable CntrDataOR : std_logic_vector(15 downto 0);
begin
	CntrDataOR := (others => '0');
	for i in 0 to 11 loop
		CntrDataOR := CntrDataOR or Cntr_Data(i);
	end loop;
	if(UsrClk'event and UsrClk = '1')then
		if(CntrRst = '1')then
			fake_word_cnt <= (others => '0');
			fake_evt_cnt <= (others => '0');
			empty_evt_cnt <= (others => '0');
			fake_header_cnt <= (others => '0');
		else
			if(fake_WrEn = '1')then
				fake_word_cnt <= fake_word_cnt + 1;
			end if;
			if(fake_CRC = '1')then
				fake_evt_cnt <= fake_evt_cnt + 1;
			end if;
			if(fake_CRC = '1' and empty_event_flag = '1')then
				empty_evt_cnt <= empty_evt_cnt + 1;
			end if;
			if(fake_WrEn = '1' and fake_header = '1')then
				fake_header_cnt <= fake_header_cnt + 1;
			end if;
		end if;
		if(CntrRst = '1' or div = x"bff")then
			div <= (others => '0');
		else
			div <= div + inc_div;
		end if;
		if(CntrRst = '1' or CntrRstCycle = '1' or div(1 downto 0) = "01")then
			Cntr_str <= '1';
		else
			Cntr_str <= '0';
		end if;
		if(CntrRstCycle = '1' or div(1 downto 0) = "11")then
			counter_wa <= div(11 downto 2);
		end if;
		if(Cntr_str = '1')then
			case div(11 downto 8) is
				when x"0" => Cntr_RdEn <= x"001";
				when x"1" => Cntr_RdEn <= x"002";
				when x"2" => Cntr_RdEn <= x"004";
				when x"3" => Cntr_RdEn <= x"008";
				when x"4" => Cntr_RdEn <= x"010";
				when x"5" => Cntr_RdEn <= x"020";
				when x"6" => Cntr_RdEn <= x"040";
				when x"7" => Cntr_RdEn <= x"080";
				when x"8" => Cntr_RdEn <= x"100";
				when x"9" => Cntr_RdEn <= x"200";
				when x"a" => Cntr_RdEn <= x"400";
				when x"b" => Cntr_RdEn <= x"800";
				when others => Cntr_RdEn <= x"000";
			end case;
		end if;
		resetCntr_SyncRegs <= resetCntr_SyncRegs(1 downto 0) & resetCntr;
		CntrRst <= not resetCntr_SyncRegs(2) and resetCntr_SyncRegs(1);
		if(CntrRst = '1')then
			CntrRstCycle <= '1';
		elsif(div(11 downto 2) = "1011111111")then
			CntrRstCycle <= '0';
		end if;
		if(CntrRstCycle = '1')then
			CounterDi <= (others => '0');
		else
			CounterDi(47 downto 16) <= CounterDoA(47 downto 16) + 1;
			CounterDi(15 downto 0) <= CntrDataOR;
		end if;
	end if;
end process;
i_AMC_refclk: IBUFDS_GTE2
    port map
    (
        O                               => AMC_REFCLK,
        ODIV2                           => open,
        CEB                             => '0',
        I                               => AMC_REFCLK_P,  -- Connect to package pin AB6
        IB                              => AMC_REFCLK_N       -- Connect to package pin AB5
    );
-- monitoring logic
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		case scale(22 downto 19) is
			when x"0" => mon_mask <= x"00000";
			when x"1" => mon_mask <= x"80000";
			when x"2" => mon_mask <= x"c0000";
			when x"3" => mon_mask <= x"e0000";
			when x"4" => mon_mask <= x"f0000";
			when x"5" => mon_mask <= x"f8000";
			when x"6" => mon_mask <= x"fc000";
			when x"7" => mon_mask <= x"fe000";
			when x"8" => mon_mask <= x"ff000";
			when x"9" => mon_mask <= x"ff800";
			when x"a" => mon_mask <= x"ffc00";
			when x"b" => mon_mask <= x"ffe00";
			when x"c" => mon_mask <= x"fff00";
			when x"d" => mon_mask <= x"fff80";
			when x"e" => mon_mask <= x"fffc0";
			when others => mon_mask <= x"fffe0";
		end case;
    if(CDF_Header = '1' and init_bldr = '1')then
			if(and_reduce(CDF_out(51 downto 32) or mon_mask) = '1')then
				sample_event <= '1';
			else
				sample_event <= '0';
			end if;
		end if;
    if(useTCPIP = true and enSFP(3) = '0' and enSFP(2 downto 0) /= "000")then
      mon_en <= '1';
			pending <= '0';
    elsif(resetSyncRegs(2) = '1')then
-- After reset, the first event will always be recorded
      mon_en <= not scale(23);
			pending <= '0';
    elsif(rst_init_bldr = '1' and LastBlock = '1')then
			if(scale(23) = '1')then
				mon_en <= sample_event and mon_buf_avl;
				pending <= '0';
			else
				mon_en <= mon_buf_avl and (and_reduce(scale_cntr) or pending);
				pending <= not mon_buf_avl and (and_reduce(scale_cntr) or pending);
			end if;
		end if;
    if(resetSyncRegs(2) = '1')then
			start_wc_reg_wa <= (others => '0');
		elsif(FirstBlock(0) = '1' and ce_wc_reg_wa = '1')then
			start_wc_reg_wa <= wc_reg_wa;
		end if;
		if(resetSyncRegs(2) = '1' or rst_mon_wc = '1')then
			mon_wc(0) <= (others => '0');
		elsif(header = '1' or sel_CDF = '1' or (LastBlock = '1' and rst_init_bldr = '1'))then
			mon_wc(0) <= mon_wc(0) + 1;
		elsif(AMC_wc_we(0) = '1')then
			mon_wc(0) <= mon_wc(0) + ("000" & AMC_wc(12 downto 0)) + 1;
		end if;
		if(resetSyncRegs(2) = '1' or rst_mon_wc = '1' or (TwoSFP = '0' and ThreeSFP = '0'))then
			mon_wc(1) <= (others => '0');
		elsif(header = '1' or sel_CDF = '1' or (LastBlock = '1' and rst_init_bldr = '1'))then
			mon_wc(1) <= mon_wc(1) + 1;
		elsif(AMC_wc_we(1) = '1')then
			mon_wc(1) <= mon_wc(1) + ("000" & AMC_wc(12 downto 0)) + 1;
		end if;
		if(resetSyncRegs(2) = '1' or rst_mon_wc = '1' or ThreeSFP = '0')then
			mon_wc(2) <= (others => '0');
		elsif(header = '1' or sel_CDF = '1' or (LastBlock = '1' and rst_init_bldr = '1'))then
			mon_wc(2) <= mon_wc(2) + 1;
		elsif(AMC_wc_we(2) = '1')then
			mon_wc(2) <= mon_wc(2) + ("000" & AMC_wc(12 downto 0)) + 1;
		end if;
		if(ce_scale = '1')then
			if(ld_scale = '1')then
				scale_cntr <= not scale(15 downto 0);
			else
				scale_cntr <= scale_cntr + 1;
			end if;
		end if;
    if(resetSyncRegs(2) = '1')then
			ce_scale <= '0';
			ld_scale <= '0';
			ce_wc_reg_wa <= '0';
			MonBufAbort <= '0';
		else
			ce_scale <= init_bldr and CDF_Header;
			ld_scale <= mon_en or pending;
			ce_wc_reg_wa <= rst_init_bldr and AMC_header(0)(64);
			MonBufAbort <= rst_init_bldr and mon_en and not AMC_header(0)(64);
		end if;
		rst_mon_wc <= rst_init_bldr;
		if(resetSyncRegs(2) = '1' or rst_mon_wc = '1')then
			en_block_wc <= (others => '0');
		else
			en_block_wc <= en_block_wc or amc_header_we;
		end if;
		for i in 0 to 2 loop
			block_wc_we(i) <= rst_init_bldr and en_block_wc(i);
		end loop;
		if(resetSyncRegs(2) = '1')then
			EventInfoRdDone <= (others => '0');
		elsif(sel_AMC = x"b")then
			EventInfoRdDone <= '1' & AMC_hasData_l;
		else
			EventInfoRdDone <= (others => '0');
		end if;
		rst_init_bldr <= EventInfoRdDone(12);
    if(resetSyncRegs(2) = '1')then
			wc_reg_wa <= (others => '0');
		elsif(MonBufAbort = '1')then
			wc_reg_wa <= start_wc_reg_wa;
		elsif(ce_wc_reg_wa = '1')then
			wc_reg_wa <= wc_reg_wa + 1;
		end if;
	end if;
end process;
g_mon_evt_wc: for i in 0 to 2 generate
	i_mon_evt_wc : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "18Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 16,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 16,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
      WRITE_MODE => "WRITE_FIRST", -- Specify "READ_FIRST" for same clock or synchronous clocks
                                   --  Specify "WRITE_FIRST for asynchrononous clocks on ports
      INIT => X"000000000000000000") --  Initial values on output port
   port map (
      DO => mon_evt_wc(i*16+15 downto i*16),         -- Output read data port, width defined by READ_WIDTH parameter
      DI => mon_wc(i),         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => ddr_pa, -- Input read address, width defined by read port depth
      RDCLK => ipb_clk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => MonBuf_empty,       -- 1-bit input reset 
      WE => "11",         -- Input write enable, width defined by write port depth
      WRADDR => wc_reg_wa, -- Input write address, width defined by write port depth
      WRCLK => sysclk,   -- 1-bit input write clock
      WREN => ce_wc_reg_wa      -- 1-bit input write port enable
   );
end generate;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		ThreeSFP <= and_reduce(EnSFP(2 downto 0));
		if(EnSFP(2 downto 0) = "011" or EnSFP(2 downto 0) = "101" or EnSFP(2 downto 0) = "110")then
			TwoSFP <= '1';
		else
			TwoSFP <= '0';
		end if;
		if(EnSFP(2 downto 0) = "001" or EnSFP(2 downto 0) = "010" or EnSFP(2 downto 0) = "100" or EnSFP(2 downto 0) = "000")then
			OneSFP <= '1';
		else
			OneSFP <= '0';
		end if;
	end if;
end process;
i_FIFO_RESET_7S: FIFO_RESET_7S PORT MAP(
		reset => resetFIFO,
		clk => sysclk,
		fifo_rst => fifo_rst,
		fifo_en => fifo_en
	);
resetFIFO <= reset or or_reduce(not AMC_txfsmresetdone and AMC_en);
end Behavioral;

